import { DEFAULT_STATE } from "./state";
import { initAnimationDuration } from "./animation";
import { initLayout } from "./layout";
import { initParser } from "./parser";
import { initInterpreter } from "./interpreter";
import { initChartLayouts } from "./chart-layouts";
import { initXDisabled } from "./x-disabled";
import { initYDisabled } from "./y-disabled";
import { initXExtendByStep } from "./x-extend-by-step";
import { initYExtendByStep } from "./y-extend-by-step";
import { initUpdate } from "./update";
import { initFacetNames } from "./facet-names";
import { initFacetOffsets } from "./facet-offsets";

function init(state) {
	for (const key in DEFAULT_STATE) {
		if (state[key] === undefined) state[key] = DEFAULT_STATE[key];
	}

	const instance = {};
	initAnimationDuration(instance);
	initLayout(instance);
	initParser(instance);
	initInterpreter(instance);
	initChartLayouts(instance);
	initXDisabled(instance);
	initYDisabled(instance);
	initXExtendByStep(instance);
	initYExtendByStep(instance);
	initFacetNames(instance);
	initFacetOffsets(instance);
	initUpdate(instance, state);

	return instance;
}
export default init;
